## ibus-chewing 2.0.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.21.0)

project(ibus-chewing VERSION 2.0.0 LANGUAGES C)
set(PRJ_SUMMARY "The Chewing engine for IBus input platform")
set(SUMMARY_TRANSLATIONS "zh_TW" "IBus新酷音輸入法")

set(PRJ_DESCRIPTION
"IBus-chewing is an IBus front-end of Chewing, an intelligent Chinese input
method for Zhuyin (BoPoMoFo) users.
It supports various Zhuyin keyboard layout, such as standard (DaChen),
IBM, Gin-Yeah, Eten, Eten 26, Hsu, Dvorak, Dvorak-Hsu, and DaChen26.

Chewing also support toned Hanyu pinyin input.")
set(DESCRIPTION_TRANSLATIONS
"zh_TW"
"IBus-chewing 是新酷音輸入法的IBus前端。
新酷音輸入法是個智慧型注音輸入法，支援多種鍵盤布局，諸如：
標準注音鍵盤、IBM、精業、倚天、倚天26鍵、許氏、Dvorak、Dvorak許氏
及大千26鍵。

本輸入法也同時支援帶調漢語拼音輸入。")

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall")

set(AUTHORS "Peng Huang, Ding-Yi Chen")
set(MAINTAINER "Ding-Yi Chen <dchen at redhat.com>")
set(VENDOR "Red Hat, APAC, Inc.")
set(LICENSE "GPLv2+")
set(PRJ_GROUP "System Environment/Libraries")
set(RRJ_URL "https://github.com/chewing/${PROJECT_NAME}")

enable_testing()
include(GNUInstallDirs)

option(GNOME_SHELL "Enable GNOME Shell support" ON)

find_package(PkgConfig REQUIRED)
pkg_check_modules(IBUS REQUIRED IMPORTED_TARGET ibus-1.0>=1.3)
pkg_check_modules(CHEWING REQUIRED IMPORTED_TARGET chewing>=0.5.1)
pkg_get_variable(CHEWING_DATADIR_REAL chewing datadir)

add_compile_definitions(
    CHEWING_VERSION_MAJOR=0
    CHEWING_VERSION_MINOR=5
    CHEWING_VERSION_PATCH=1
)

pkg_check_modules(GLIB2 REQUIRED IMPORTED_TARGET glib-2.0)
pkg_check_modules(GTK4 REQUIRED IMPORTED_TARGET gtk4)
pkg_check_modules(LIBADWAITA REQUIRED IMPORTED_TARGET libadwaita-1)

find_program(GLIB_COMPILE_RESOURCES NAMES glib-compile-resources REQUIRED)
find_program(GLIB_COMPILE_SCHEMAS NAMES glib-compile-schemas)

set(CMAKE_C_STANDARD 99)
add_compile_definitions(_XOPEN_SOURCE)

# Directory that store ibus-chewing icons
add_compile_definitions(PRJ_ICON_DIR="${CMAKE_INSTALL_DATADIR}/ibus-chewing/icons")

# GSettings/GConf schemas
set(PROJECT_SCHEMA_ID org.freedesktop.IBus.Chewing)
set(LIBEXEC_DIR ${CMAKE_INSTALL_FULL_LIBEXECDIR})
set(PRJ_DATA_DIR ${CMAKE_INSTALL_FULL_DATADIR}/ibus-chewing)
set(PRJ_VER ${CMAKE_PROJECT_VERSION})
add_compile_definitions(
    PROJECT_NAME=${CMAKE_PROJECT_NAME}
    PROJECT_SCHEMA_ID=${PROJECT_SCHEMA_ID}
    # TODO path deprecated
    PROJECT_SCHEMA_BASE=/desktop/ibus/engine
    PROJECT_SCHEMA_SECTION=chewing
    PROJECT_SCHEMA_DIR=/desktop/ibus/engine/chewing
    PROJECT_SCHEMA_PATH=/desktop/ibus/engine/chewing/
    DATA_DIR=${CMAKE_INSTALL_FULL_DATADIR}
    PRJ_DATA_DIR=${PRJ_DATA_DIR}
    PRJ_VER=${PRJ_VER}
    PRJ_URL=${PRJ_URL}
    LIBEXEC_DIR=${LIBEXEC_DIR}
    CHEWING_DATADIR_REAL=${CHEWING_DATADIR_REAL}
)

# chewing.xml
set(ICON_PROP_KEY "<icon_prop_key>InputMode</icon_prop_key>")
set(SYMBOL_XML "<symbol>&#x9177;</symbol>")
set(CHEWING_HOTKEYS "Super+space")
set(HOTKEYS_XML "<hotkeys>${CHEWING_HOTKEYS}</hotkeys>")
set(SETUP_PROGRAM_XML "<setup>${CMAKE_INSTALL_FULL_LIBEXECDIR}/ibus-setup-chewing</setup>")

if(IBUS_VERSION LESS 1.5.11)
    set(ICON_PROP_KEY "<!-- ${ICON_PROP_KEY} -->")
endif()
if(IBUS_VERSION LESS 1.3.99)
    set(SYMBOL_XML "<!-- ${SYMBOL_XML} -->")
    set(HOTKEYS_XML "<!-- ${HOTKEYS_XML} -->")
    set(SETUP_PROGRAM_XML "<!-- ${SETUP_PROGRAM_XML} -->")
endif()

configure_file(data/chewing.xml.in data/chewing.xml)
configure_file(data/ibus-setup-chewing.desktop.in data/ibus-setup-chewing.desktop)

add_subdirectory(po)
add_subdirectory(src bin)
add_subdirectory(test)

install(FILES AUTHORS README.md CHANGELOG.md ChangeLog-1.x COPYING USER-GUIDE
    DESTINATION ${CMAKE_INSTALL_DOCDIR})
install(FILES ${CMAKE_BINARY_DIR}/data/chewing.xml
    DESTINATION ${CMAKE_INSTALL_DATADIR}/ibus/component)
install(FILES ${CMAKE_BINARY_DIR}/data/ibus-setup-chewing.desktop
    DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
install(DIRECTORY icons
    DESTINATION ${CMAKE_INSTALL_DATADIR}/ibus-chewing)

set(CPACK_PACKAGE_CHECKSUM SHA256)
set(CPACK_SOURCE_IGNORE_FILES "/build" "/out" "/\\\\..*")
set(CPACK_SOURCE_GENERATOR TXZ)
include(CPack)

=== src/CMakeLists.txt ===
add_library(common STATIC
    IBusChewingApplier.c
    IBusChewingProperties.c
    IBusChewingLookupTable.c
    MakerDialogBackend.c
    MakerDialogProperty.c
    MakerDialogUtil.c

    IBusChewingLookupTable.h
    IBusChewingProperties.h
    MakerDialogBackend.h
    MakerDialogProperty.h
    MakerDialogPropertySpec.h
    MakerDialogUtil.h
    ibus-chewing-engine.h
)
target_link_libraries(common PUBLIC
    PkgConfig::CHEWING
    PkgConfig::GLIB2
    PkgConfig::IBUS
)

add_library(gui-core STATIC
    GSettingsBackend.c
    GSettingsBackend.h
)
target_link_libraries(gui-core PUBLIC
    common
    PkgConfig::GLIB2
    PkgConfig::GTK4
    PkgConfig::LIBADWAITA
    PkgConfig::IBUS
    PkgConfig::CHEWING
)

add_custom_command(
    OUTPUT ibus-setup-chewing-window-ui.c
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/setup
    COMMAND ${GLIB_COMPILE_RESOURCES}
    ARGS
        --generate
        --target=${CMAKE_CURRENT_BINARY_DIR}/ibus-setup-chewing-window-ui.c
        ibus-setup-chewing.gresource.xml
    VERBATIM
    MAIN_DEPENDENCY setup/ibus-setup-chewing.gresource.xml
    DEPENDS
        setup/ibus-setup-chewing-window.ui
)
set_source_files_properties(
    ${CMAKE_CURRENT_BINARY_DIR}/ibus-setup-chewing-window-ui.c
    PROPERTIES GENERATED TRUE
)
add_executable(ibus-setup-chewing
    setup/ibus-setup-chewing-application.c
    setup/ibus-setup-chewing-application.h
    setup/ibus-setup-chewing-window.c
    setup/ibus-setup-chewing-window.h
    setup/main.c
    ${CMAKE_CURRENT_BINARY_DIR}/ibus-setup-chewing-window-ui.c
)
target_compile_definitions(ibus-setup-chewing PRIVATE
    GETTEXT_PACKAGE="ibus-chewing"
    LOCALEDIR="${CMAKE_INSTALL_FULL_LOCALEDIR}"
)
target_include_directories(ibus-setup-chewing PRIVATE setup)
target_link_libraries(ibus-setup-chewing PkgConfig::LIBADWAITA)

add_executable(ibus-engine-chewing
    ibus-chewing-engine.c
    ibus-chewing-engine.h
    IBusChewingLookupTable.c
    IBusChewingLookupTable.h
    IBusChewingPreEdit.c
    IBusChewingPreEdit.h
    IBusChewingUtil.c
    IBusChewingUtil.h
    main.c
)
target_compile_definitions(ibus-engine-chewing
    PRIVATE VERBOSE_LEVEL=$<IF:$<CONFIG:Debug>,DEBUG,WARN>)
target_include_directories(ibus-engine-chewing
    PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})

target_link_libraries(ibus-engine-chewing gui-core)

set(PROJECT_GSCHEMA_XML ${PROJECT_SCHEMA_ID}.gschema.xml)
set(GSETTINGS_SCHEMAS_DIR ${CMAKE_INSTALL_DATADIR}/glib-2.0/schemas)

install(FILES setup/${PROJECT_GSCHEMA_XML}
    DESTINATION ${GSETTINGS_SCHEMAS_DIR}
)
if(GLIB_COMPILE_SCHEMAS)
    install(CODE "execute_process(COMMAND glib-compile-schemas ${CMAKE_INSTALL_PREFIX}/${GSETTINGS_SCHEMAS_DIR})")
endif()

install(TARGETS ibus-engine-chewing ibus-setup-chewing
    DESTINATION ${CMAKE_INSTALL_LIBEXECDIR})

=== test/CMakeLists.txt ===
add_compile_definitions(UNIT_TEST)
include_directories(${CMAKE_SOURCE_DIR}/src)

# ==================
add_executable(MakerDialogUtil-test MakerDialogUtil-test.c)
target_link_libraries(MakerDialogUtil-test common)
add_test(NAME MakerDialogUtil
    COMMAND gtester ${CMAKE_CURRENT_BINARY_DIR}/MakerDialogUtil-test)

# ==================
add_executable(MakerDialogBackend-test MakerDialogBackend-test.c)
target_link_libraries(MakerDialogBackend-test gui-core)
add_test(NAME MakerDialogBackend
    COMMAND gtester ${CMAKE_CURRENT_BINARY_DIR}/MakerDialogBackend-test)
set_tests_properties(MakerDialogBackend PROPERTIES
    ENVIRONMENT "GSETTINGS_SCHEMA_DIR=${CMAKE_BINARY_DIR}/bin")

# ==================
add_executable(IBusChewingUtil-test IBusChewingUtil-test.c
    ../src/IBusChewingUtil.c
    ../src/IBusChewingUtil.h
)
target_link_libraries(IBusChewingUtil-test gui-core)
add_test(NAME IBusChewingUtil
    COMMAND gtester ${CMAKE_CURRENT_BINARY_DIR}/IBusChewingUtil-test)

# ==================
add_executable(IBusChewingPreEdit-test IBusChewingPreEdit-test.c
    ../src/IBusChewingUtil.c
    ../src/IBusChewingUtil.h
    ../src/IBusChewingPreEdit.c
    ../src/IBusChewingPreEdit.h
)
target_link_libraries(IBusChewingPreEdit-test gui-core)
add_test(NAME IBusChewingPreEdit
    COMMAND gtester ${CMAKE_CURRENT_BINARY_DIR}/IBusChewingUtil-test)

# ==================
add_executable(ibus-chewing-engine-test ibus-chewing-engine-test.c
    ../src/ibus-chewing-engine.c
    ../src/ibus-chewing-engine.h
    ../src/IBusChewingLookupTable.c
    ../src/IBusChewingLookupTable.h
    ../src/IBusChewingPreEdit.c
    ../src/IBusChewingPreEdit.h
    ../src/IBusChewingUtil.c
    ../src/IBusChewingUtil.h
)
target_link_libraries(ibus-chewing-engine-test gui-core)
add_test(NAME ibus-chewing-engine
    COMMAND gtester ${CMAKE_CURRENT_BINARY_DIR}/ibus-chewing-engine-test)
set_tests_properties(ibus-chewing-engine PROPERTIES
    ENVIRONMENT "GSETTINGS_SCHEMA_DIR=${CMAKE_BINARY_DIR}/bin")

# ==================
add_test(NAME ibus-setup-chewing
    COMMAND ${CMAKE_BINARY_DIR}/bin/ibus-setup-chewing -q)
set_tests_properties(ibus-setup-chewing PROPERTIES
    ENVIRONMENT "GSETTINGS_SCHEMA_DIR=${CMAKE_BINARY_DIR}/bin")

=== debian/changelog ===
ibus-chewing (2.0.0-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 08:57:25 +0000

ibus-chewing (2.0.0-1build1) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 05:05:47 +0000

ibus-chewing (2.0.0-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.6.2.
  * Change upstream to https://github.com/chewing.
  * d/control: Add Rules-Requires-Root: no.
  * d/rules: Remove unused rules.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Mon, 19 Feb 2024 02:34:07 +0800

=== debian/control ===
Source: ibus-chewing
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
Uploaders: Asias He <asias.hejun@gmail.com>,
           Osamu Aoki <osamu@debian.org>,
           ChangZhuo Chen (陳昌倬) <czchen@debian.org>,
Build-Depends: debhelper-compat (= 13),
               cmake,
               libadwaita-1-dev,
               libchewing3-dev (>= 0.5.1),
               libgtk-4-dev,
               libibus-1.0-dev (>= 1.3.99.20110419),
Standards-Version: 4.6.2
Homepage: https://github.com/chewing/ibus-chewing
Vcs-Git: https://salsa.debian.org/debian/ibus-chewing.git
Vcs-Browser: https://salsa.debian.org/debian/ibus-chewing
Rules-Requires-Root: no

Package: ibus-chewing
Architecture: any
Depends:
 ibus (>= 1.5.22-2),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Chewing engine for IBus
 IBus is an Intelligent Input Bus. It is a new input framework for Linux
 OS. It provides full featured and user friendly input method user interface.
 It also may help developers to develop input method easily.
 .
 IBus-chewing is a IBus based IM Engine for Traditional Chinese

## ibus-chewing 2.1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,31 @@
 cmake_minimum_required(VERSION 3.21.0)
 
-project(ibus-chewing VERSION 2.0.0 LANGUAGES C)
+project(ibus-chewing LANGUAGES C)
 set(PRJ_SUMMARY "The Chewing engine for IBus input platform")
 set(SUMMARY_TRANSLATIONS "zh_TW" "IBus新酷音輸入法")
+
+set(PRJ_VER_MAJOR 2)
+set(PRJ_VER_MINOR 1)
+set(PRJ_VER_PATCH 1)
+# set(PRJ_VER_EXTRA "")
+
+set(PRJ_VER "${PRJ_VER_MAJOR}.${PRJ_VER_MINOR}.${PRJ_VER_PATCH}")
+if(DEFINED PRJ_VER_EXTRA)
+  string(APPEND PRJ_VER "-${PRJ_VER_EXTRA}")
+endif()
+
+find_package(Git)
+if(Git_FOUND)
+    execute_process(
+        COMMAND ${GIT_EXECUTABLE} --work-tree ${CMAKE_SOURCE_DIR} describe --dirty --always
+        OUTPUT_STRIP_TRAILING_WHITESPACE
+        OUTPUT_VARIABLE GIT_DESCRIBE
+        ERROR_VARIABLE GIT_DESCRIBE_ERROR
+    )
+    if(NOT GIT_DESCRIBE_ERROR)
+        string(REPLACE "v" "" PRJ_VER ${GIT_DESCRIBE})
+    endif()
+endif()
 
 set(PRJ_DESCRIPTION
 "IBus-chewing is an IBus front-end of Chewing, an intelligent Chinese input
@@ -20,7 +43,11 @@
 
 本輸入法也同時支援帶調漢語拼音輸入。")
 
-set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall")
+option(ERROR_ON_WARNING "Toggle error-on-warning build" OFF)
+set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wextra")
+if(ERROR_ON_WARNING)
+    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")
+endif()
 
 set(AUTHORS "Peng Huang, Ding-Yi Chen")
 set(MAINTAINER "Ding-Yi Chen <dchen at redhat.com>")
@@ -29,6 +56,8 @@
 set(PRJ_GROUP "System Environment/Libraries")
 set(RRJ_URL "https://github.com/chewing/${PROJECT_NAME}")
 
+set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
+
 enable_testing()
 include(GNUInstallDirs)
 
@@ -36,13 +65,13 @@
 
 find_package(PkgConfig REQUIRED)
 pkg_check_modules(IBUS REQUIRED IMPORTED_TARGET ibus-1.0>=1.3)
-pkg_check_modules(CHEWING REQUIRED IMPORTED_TARGET chewing>=0.5.1)
+pkg_check_modules(CHEWING REQUIRED IMPORTED_TARGET chewing>=0.9.0)
 pkg_get_variable(CHEWING_DATADIR_REAL chewing datadir)
 
 add_compile_definitions(
     CHEWING_VERSION_MAJOR=0
-    CHEWING_VERSION_MINOR=5
-    CHEWING_VERSION_PATCH=1
+    CHEWING_VERSION_MINOR=9
+    CHEWING_VERSION_PATCH=0
 )
 
 pkg_check_modules(GLIB2 REQUIRED IMPORTED_TARGET glib-2.0)
@@ -52,7 +81,7 @@
 find_program(GLIB_COMPILE_RESOURCES NAMES glib-compile-resources REQUIRED)
 find_program(GLIB_COMPILE_SCHEMAS NAMES glib-compile-schemas)
 
-set(CMAKE_C_STANDARD 99)
+set(CMAKE_C_STANDARD 23)
 add_compile_definitions(_XOPEN_SOURCE)
 
 # Directory that store ibus-chewing icons
@@ -62,7 +91,6 @@
 set(PROJECT_SCHEMA_ID org.freedesktop.IBus.Chewing)
 set(LIBEXEC_DIR ${CMAKE_INSTALL_FULL_LIBEXECDIR})
 set(PRJ_DATA_DIR ${CMAKE_INSTALL_FULL_DATADIR}/ibus-chewing)
-set(PRJ_VER ${CMAKE_PROJECT_VERSION})
 add_compile_definitions(
     PROJECT_NAME=${CMAKE_PROJECT_NAME}
     PROJECT_SCHEMA_ID=${PROJECT_SCHEMA_ID}
@@ -75,6 +103,8 @@
     PRJ_DATA_DIR=${PRJ_DATA_DIR}
     PRJ_VER=${PRJ_VER}
     PRJ_URL=${PRJ_URL}
+    IBUS_VERSION=${IBUS_VERSION}
+    CHEWING_VERSION=${CHEWING_VERSION}
     LIBEXEC_DIR=${LIBEXEC_DIR}
     CHEWING_DATADIR_REAL=${CHEWING_DATADIR_REAL}
 )
@@ -110,7 +140,10 @@
     DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
 install(DIRECTORY icons
     DESTINATION ${CMAKE_INSTALL_DATADIR}/ibus-chewing)
+install(FILES icons/org.freedesktop.IBus.Chewing.Setup.svg
+    DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps)
 
+set(CPACK_PACKAGE_VERSION ${PRJ_VER})
 set(CPACK_PACKAGE_CHECKSUM SHA256)
 set(CPACK_SOURCE_IGNORE_FILES "/build" "/out" "/\\\\..*")
 set(CPACK_SOURCE_GENERATOR TXZ)

=== debian/changelog ===
ibus-chewing (2.1.1-1) unstable; urgency=medium

  * New upstream release.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Wed, 21 Aug 2024 09:54:24 +0800

ibus-chewing (2.1.0-1) unstable; urgency=medium

  [ ChangZhuo Chen (陳昌倬) ]
  * New upstream release.
  * Update Vcs-* to input-method-team.

  [ Boyuan Yang ]
  * Remove unnecessary constraints.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Tue, 13 Aug 2024 00:18:03 +0800

## ibus-chewing 2.1.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 
 set(PRJ_VER_MAJOR 2)
 set(PRJ_VER_MINOR 1)
-set(PRJ_VER_PATCH 1)
+set(PRJ_VER_PATCH 2)
 # set(PRJ_VER_EXTRA "")
 
 set(PRJ_VER "${PRJ_VER_MAJOR}.${PRJ_VER_MINOR}.${PRJ_VER_PATCH}")

=== debian/changelog ===
ibus-chewing (2.1.2-1) unstable; urgency=medium

  * New upstream release.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Tue, 08 Oct 2024 09:35:33 +0800

## ibus-chewing 2.1.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 
 set(PRJ_VER_MAJOR 2)
 set(PRJ_VER_MINOR 1)
-set(PRJ_VER_PATCH 2)
+set(PRJ_VER_PATCH 3)
 # set(PRJ_VER_EXTRA "")
 
 set(PRJ_VER "${PRJ_VER_MAJOR}.${PRJ_VER_MINOR}.${PRJ_VER_PATCH}")

=== debian/changelog ===
ibus-chewing (2.1.3-1) unstable; urgency=medium

  * New upstream release.
  * d/copyright: Update copyright year.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Wed, 01 Jan 2025 22:08:18 +0800

## ibus-chewing 2.1.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 
 set(PRJ_VER_MAJOR 2)
 set(PRJ_VER_MINOR 1)
-set(PRJ_VER_PATCH 3)
+set(PRJ_VER_PATCH 4)
 # set(PRJ_VER_EXTRA "")
 
 set(PRJ_VER "${PRJ_VER_MAJOR}.${PRJ_VER_MINOR}.${PRJ_VER_PATCH}")

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,16 +1,8 @@
 add_library(common STATIC
-    IBusChewingApplier.c
-    IBusChewingProperties.c
     IBusChewingLookupTable.c
-    MakerDialogBackend.c
-    MakerDialogProperty.c
     MakerDialogUtil.c
 
     IBusChewingLookupTable.h
-    IBusChewingProperties.h
-    MakerDialogBackend.h
-    MakerDialogProperty.h
-    MakerDialogPropertySpec.h
     MakerDialogUtil.h
     ibus-chewing-engine.h
 )
@@ -18,19 +10,6 @@
     PkgConfig::CHEWING
     PkgConfig::GLIB2
     PkgConfig::IBUS
-)
-
-add_library(gui-core STATIC
-    GSettingsBackend.c
-    GSettingsBackend.h
-)
-target_link_libraries(gui-core PUBLIC
-    common
-    PkgConfig::GLIB2
-    PkgConfig::GTK4
-    PkgConfig::LIBADWAITA
-    PkgConfig::IBUS
-    PkgConfig::CHEWING
 )
 
 add_custom_command(
@@ -55,6 +34,8 @@
     setup/ibus-setup-chewing-application.h
     setup/ibus-setup-chewing-window.c
     setup/ibus-setup-chewing-window.h
+    setup/ibus-setup-chewing-about.c
+    setup/ibus-setup-chewing-about.h
     setup/main.c
     ${CMAKE_CURRENT_BINARY_DIR}/ibus-setup-chewing-window-ui.c
 )
@@ -63,7 +44,10 @@
     LOCALEDIR="${CMAKE_INSTALL_FULL_LOCALEDIR}"
 )
 target_include_directories(ibus-setup-chewing PRIVATE setup)
-target_link_libraries(ibus-setup-chewing PkgConfig::LIBADWAITA)
+target_link_libraries(ibus-setup-chewing
+    PkgConfig::LIBADWAITA
+    PkgConfig::CHEWING
+)
 
 add_executable(ibus-engine-chewing
     ibus-chewing-engine.c
@@ -81,7 +65,14 @@
 target_include_directories(ibus-engine-chewing
     PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
 
-target_link_libraries(ibus-engine-chewing gui-core)
+target_link_libraries(ibus-engine-chewing
+    common
+    PkgConfig::GLIB2
+    PkgConfig::GTK4
+    PkgConfig::LIBADWAITA
+    PkgConfig::IBUS
+    PkgConfig::CHEWING
+)
 
 set(PROJECT_GSCHEMA_XML ${PROJECT_SCHEMA_ID}.gschema.xml)
 set(GSETTINGS_SCHEMAS_DIR ${CMAKE_INSTALL_DATADIR}/glib-2.0/schemas)
@@ -90,7 +81,7 @@
     DESTINATION ${GSETTINGS_SCHEMAS_DIR}
 )
 if(GLIB_COMPILE_SCHEMAS)
-    install(CODE "execute_process(COMMAND glib-compile-schemas ${CMAKE_INSTALL_PREFIX}/${GSETTINGS_SCHEMAS_DIR})")
+    install(CODE "execute_process(COMMAND glib-compile-schemas \${CMAKE_INSTALL_PREFIX}/${GSETTINGS_SCHEMAS_DIR})")
 endif()
 
 install(TARGETS ibus-engine-chewing ibus-setup-chewing

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -8,30 +8,23 @@
     COMMAND gtester ${CMAKE_CURRENT_BINARY_DIR}/MakerDialogUtil-test)
 
 # ==================
-add_executable(MakerDialogBackend-test MakerDialogBackend-test.c)
-target_link_libraries(MakerDialogBackend-test gui-core)
-add_test(NAME MakerDialogBackend
-    COMMAND gtester ${CMAKE_CURRENT_BINARY_DIR}/MakerDialogBackend-test)
-set_tests_properties(MakerDialogBackend PROPERTIES
-    ENVIRONMENT "GSETTINGS_SCHEMA_DIR=${CMAKE_BINARY_DIR}/bin")
-
-# ==================
 add_executable(IBusChewingUtil-test IBusChewingUtil-test.c
     ../src/IBusChewingUtil.c
     ../src/IBusChewingUtil.h
 )
-target_link_libraries(IBusChewingUtil-test gui-core)
+target_link_libraries(IBusChewingUtil-test common)
 add_test(NAME IBusChewingUtil
     COMMAND gtester ${CMAKE_CURRENT_BINARY_DIR}/IBusChewingUtil-test)
 
 # ==================
 add_executable(IBusChewingPreEdit-test IBusChewingPreEdit-test.c
+    ../src/ibus-chewing-engine.c
     ../src/IBusChewingUtil.c
     ../src/IBusChewingUtil.h
     ../src/IBusChewingPreEdit.c
     ../src/IBusChewingPreEdit.h
 )
-target_link_libraries(IBusChewingPreEdit-test gui-core)
+target_link_libraries(IBusChewingPreEdit-test common PkgConfig::GTK4)
 add_test(NAME IBusChewingPreEdit
     COMMAND gtester ${CMAKE_CURRENT_BINARY_DIR}/IBusChewingUtil-test)
 
@@ -46,7 +39,7 @@
     ../src/IBusChewingUtil.c
     ../src/IBusChewingUtil.h
 )
-target_link_libraries(ibus-chewing-engine-test gui-core)
+target_link_libraries(ibus-chewing-engine-test common PkgConfig::GTK4)
 add_test(NAME ibus-chewing-engine
     COMMAND gtester ${CMAKE_CURRENT_BINARY_DIR}/ibus-chewing-engine-test)
 set_tests_properties(ibus-chewing-engine PROPERTIES
@@ -57,3 +50,7 @@
     COMMAND ${CMAKE_BINARY_DIR}/bin/ibus-setup-chewing -q)
 set_tests_properties(ibus-setup-chewing PROPERTIES
     ENVIRONMENT "GSETTINGS_SCHEMA_DIR=${CMAKE_BINARY_DIR}/bin")
+add_test(NAME ibus-setup-chewing-about
+    COMMAND ${CMAKE_BINARY_DIR}/bin/ibus-setup-chewing --about -q)
+set_tests_properties(ibus-setup-chewing-about PROPERTIES
+    ENVIRONMENT "GSETTINGS_SCHEMA_DIR=${CMAKE_BINARY_DIR}/bin")

=== debian/changelog ===
ibus-chewing (2.1.4-1) unstable; urgency=medium

  * New upstream release.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Wed, 26 Feb 2025 00:13:08 +0800

=== debian/control ===
Source: ibus-chewing
Section: utils
Priority: optional
Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
Uploaders: Asias He <asias.hejun@gmail.com>,
           Osamu Aoki <osamu@debian.org>,
           ChangZhuo Chen (陳昌倬) <czchen@debian.org>,
Build-Depends: debhelper-compat (= 13),
               cmake,
               libadwaita-1-dev,
               libchewing3-dev (>= 0.9.0~),
               libgtk-4-dev,
               libibus-1.0-dev,
Standards-Version: 4.7.0
Homepage: https://github.com/chewing/ibus-chewing
Vcs-Git: https://salsa.debian.org/input-method-team/ibus-chewing.git
Vcs-Browser: https://salsa.debian.org/input-method-team/ibus-chewing
Rules-Requires-Root: no

Package: ibus-chewing
Architecture: any
Depends:
 ibus (>= 1.5.22-2),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Chewing engine for IBus
 IBus is an Intelligent Input Bus. It is a new input framework for Linux
 OS. It provides full featured and user friendly input method user interface.
 It also may help developers to develop input method easily.
 .
 IBus-chewing is a IBus based IM Engine for Traditional Chinese

## ibus-chewing 2.1.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.21.0)
+cmake_minimum_required(VERSION 3.21.0...3.31.6)
 
 project(ibus-chewing LANGUAGES C)
 set(PRJ_SUMMARY "The Chewing engine for IBus input platform")
@@ -6,7 +6,7 @@
 
 set(PRJ_VER_MAJOR 2)
 set(PRJ_VER_MINOR 1)
-set(PRJ_VER_PATCH 4)
+set(PRJ_VER_PATCH 5)
 # set(PRJ_VER_EXTRA "")
 
 set(PRJ_VER "${PRJ_VER_MAJOR}.${PRJ_VER_MINOR}.${PRJ_VER_PATCH}")

=== debian/changelog ===
ibus-chewing (2.1.5-1) unstable; urgency=medium

  * New upstream version 2.1.5

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Thu, 21 Aug 2025 22:16:14 +0800

## ibus-chewing 2.1.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 
 set(PRJ_VER_MAJOR 2)
 set(PRJ_VER_MINOR 1)
-set(PRJ_VER_PATCH 5)
+set(PRJ_VER_PATCH 6)
 # set(PRJ_VER_EXTRA "")
 
 set(PRJ_VER "${PRJ_VER_MAJOR}.${PRJ_VER_MINOR}.${PRJ_VER_PATCH}")

=== debian/changelog ===
ibus-chewing (2.1.6-1) unstable; urgency=medium

  * New upstream version 2.1.6
  * d/control: Bump Standards-Version to 4.7.2.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Wed, 27 Aug 2025 20:03:36 +0800

## ibus-chewing 2.1.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 
 set(PRJ_VER_MAJOR 2)
 set(PRJ_VER_MINOR 1)
-set(PRJ_VER_PATCH 6)
+set(PRJ_VER_PATCH 7)
 # set(PRJ_VER_EXTRA "")
 
 set(PRJ_VER "${PRJ_VER_MAJOR}.${PRJ_VER_MINOR}.${PRJ_VER_PATCH}")

=== po/CMakeLists.txt ===
set(languages ca cs de es fr it ja ko pa pl pt_BR uk zh_CN zh_TW)

include(FindGettext)

foreach(lang ${languages})
    GETTEXT_PROCESS_PO_FILES(${lang} ALL
        PO_FILES ${lang}.po)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${lang}.gmo DESTINATION
        ${CMAKE_INSTALL_LOCALEDIR}/${lang}/LC_MESSAGES/ RENAME ibus-chewing.mo)
endforeach()

=== test/CMakeLists.txt ===
add_compile_definitions(UNIT_TEST)
include_directories(${CMAKE_SOURCE_DIR}/src)

# ==================
add_executable(maker-dialog-util-test maker-dialog-util-test.c)
target_link_libraries(maker-dialog-util-test common)
add_test(NAME maker-dialog-util
    COMMAND gtester ${CMAKE_CURRENT_BINARY_DIR}/maker-dialog-util-test)

# ==================
add_executable(ibus-chewing-util-test ibus-chewing-util-test.c
    ../src/ibus-chewing-util.c
    ../src/ibus-chewing-util.h
    ./test-util.h
)
target_link_libraries(ibus-chewing-util-test common)
add_test(NAME ibus-chewing-util
    COMMAND gtester ${CMAKE_CURRENT_BINARY_DIR}/ibus-chewing-util-test)

# ==================
add_executable(ibus-chewing-preedit-test ibus-chewing-preedit-test.c
    ../src/ibus-chewing-engine.c
    ../src/ibus-chewing-util.c
    ../src/ibus-chewing-util.h
    ../src/ibus-chewing-preedit.c
    ../src/ibus-chewing-preedit.h
)
target_link_libraries(ibus-chewing-preedit-test common PkgConfig::GTK4)
add_test(NAME ibus-chewing-preedit
    COMMAND gtester ${CMAKE_CURRENT_BINARY_DIR}/ibus-chewing-preedit-test)

# ==================
add_executable(ibus-chewing-engine-test ibus-chewing-engine-test.c
    ../src/ibus-chewing-engine.c
    ../src/ibus-chewing-engine.h
    ../src/ibus-chewing-lookup-table.c
    ../src/ibus-chewing-lookup-table.h
    ../src/ibus-chewing-preedit.c
    ../src/ibus-chewing-preedit.h
    ../src/ibus-chewing-util.c
    ../src/ibus-chewing-util.h
)
target_link_libraries(ibus-chewing-engine-test common PkgConfig::GTK4)
add_test(NAME ibus-chewing-engine
    COMMAND gtester ${CMAKE_CURRENT_BINARY_DIR}/ibus-chewing-engine-test)
set_tests_properties(ibus-chewing-engine PROPERTIES
    ENVIRONMENT "GSETTINGS_SCHEMA_DIR=${CMAKE_BINARY_DIR}/bin")

# ==================
add_test(NAME ibus-setup-chewing
    COMMAND ${CMAKE_BINARY_DIR}/bin/ibus-setup-chewing -q)
set_tests_properties(ibus-setup-chewing PROPERTIES
    ENVIRONMENT "GSETTINGS_SCHEMA_DIR=${CMAKE_BINARY_DIR}/bin")
add_test(NAME ibus-setup-chewing-about
    COMMAND ${CMAKE_BINARY_DIR}/bin/ibus-setup-chewing --about -q)
set_tests_properties(ibus-setup-chewing-about PROPERTIES
    ENVIRONMENT "GSETTINGS_SCHEMA_DIR=${CMAKE_BINARY_DIR}/bin")

=== debian/changelog ===
ibus-chewing (2.1.7-1) unstable; urgency=medium

  * New upstream version 2.1.7

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sat, 06 Sep 2025 08:24:18 +0800

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
                libchewing3-dev (>= 0.9.0~),
                libgtk-4-dev,
                libibus-1.0-dev,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/chewing/ibus-chewing
 Vcs-Git: https://salsa.debian.org/input-method-team/ibus-chewing.git
 Vcs-Browser: https://salsa.debian.org/input-method-team/ibus-chewing

=== debian/rules ===
#!/usr/bin/make -f
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND =

CFLAGS+=$(CPPFLAGS)

%:
	dh $@

override_dh_auto_test:
	# FIXME: fix unit test

=== debian/watch ===
version=4

opts="downloadurlmangle=s/archive\/refs\/tags\/(v?([.\d]+))[.]tar[.]gz/releases\/download\/$1\/@PACKAGE@-$2-Source\.tar\.xz/" \
https://github.com/chewing/@PACKAGE@/tags .*/v?([.\d]+)[.]tar[.]gz
